<?php
/**
 * CakePHP Patch: Extending CakePHP's CacheHelper to use Cache Engines
 * http://www.datumbox.com/
 *
 * Copyright 2013, Vasilis Vryniotis
 * Licensed under MIT or GPLv3, see LICENSE
 */
 
//The /app/View/MyView.php extends CakePHP's View class
//======================================================
App::uses('View', 'View');
class MyView extends View {
    /**
    *
    * The renderCacheFromString() is exactly the same us renderCache() function with only difference the fact that we dont 
    * read the contents of the cache from a file, but instead we have it in a string variable.
    * 
    */
    public function renderCacheFromString($out, $timeStart) {
        //simlar to renderCache(). The only difference is that instead of reading the data from file, it takes it directly from a string
        ob_start();
        //the original renderCache() function includes the cached file. The equivalent of including a file is evaluating the string
        eval("?>" . $out . "<?php "); //This is so ugly!!! Find alternatives?
        $out = ob_get_clean();
         
        //BELOW this point the code is the SAME as in CakePHP's method
        //============================================================
        if (preg_match('/^<!--cachetime:(\\d+)-->/', $out, $match)) {
            if (time() >= $match['1']) {
                //@codingStandardsIgnoreStart
                @unlink($filename);
                //@codingStandardsIgnoreEnd
                unset($out);
                return false;
            } else {
                if ($this->layout === 'xml') {
                    header('Content-type: text/xml');
                }
                return substr($out, strlen($match[0]));
            }
        }
        //Up to this point the code is the SAME as in CakePHP's method
        //============================================================
    }
}